# 给符号赋值
终于到达这一章：计算。在 `REPL`中的 `E` 就是解释器在处理源代码的的过程中的最后一步。在这一步，源代码将会变得有意义。没有计算，诸如 `1+2`这样的表达式仅仅是一连串的字符，token或者代表表达式的树状结构，而并没有意味着任何事情，当然，我们都知道 `1+2` 变成 `3`, `3.5 > 1` 是 `true`, `5<1` 是 `false`, `put("Hello World!")` 将会输出友好的消息。

计算的过程就是定义解释器如何将编程语言编程解释后的结果。
```
let num = 5;
if (num) {
    return a;
} else {
    return b;
}
```
是否返回 `a` 或者 `b` 将去取决于解释器在计算整数 `5` 是否为真。在一些语言中，它是真值，但是在其他语言中，我们需要用一个表达式来生成布尔值，如 `5 != 0`。

考虑如下
```
let one = fn() {
    printLine("one");
    return 1;
};

let two = fn() {
    printLine("two");
    return 2;
};
add(one(), two())
```
输出的结果是第一个 `one` 还是 `two` 函数亦或者是其他的？ 这个取决于特定的编程语言，最终是取决于解释器的实现，它是如何在一个函数调用的表达式中计算参数的顺序。

这样微小的选择方式在本章中还有很多，我们将决定在 Monkey 编程语言中如何进行工作，并且我们的解释器如何计算源代码。

或许你非常怀疑我告诉你写一个解析器非常好玩，但是请相信我，这事最重要的部分，在这部分Monkey编程语言将会变得有生命力起来，尤其是源代码变得运动起来，仿佛开始呼吸一样。
